package stamp.peripheral.wireless.linkmatik;

public class Brick {

  private static char direct        = 0x00;
  private static char system        = 0x01;
  private static char reply         = 0x02;

  private static char noreplyNeeded = 0x80;
  private static char replyNeeded   = 0x00;

  private static char beep          = 0x03;

  Serial              spp;

  char[] tempCharArray = new char[25];
  int payloadLength = 0;

  public Brick(Serial s) {
    this.spp = s;
  }

  private void length(){
    payloadLength -=2;
    tempCharArray[0] = (char) (payloadLength & 0x00ff);
    tempCharArray[1] = (char) ((payloadLength >> 8) & 0x00ff);;
  }


  public void beep(int time, int freq) {
    payloadLength = 2;
    tempCharArray[payloadLength] = direct;
    tempCharArray[payloadLength++] |= noreplyNeeded;

    tempCharArray[payloadLength++] = beep;

    tempCharArray[payloadLength++] = (char) (freq & 0x00ff);
    tempCharArray[payloadLength++] = (char) ((freq >> 8) & 0x00ff);

    tempCharArray[payloadLength++] = (char) (time & 0x00ff);
    tempCharArray[payloadLength] = (char) ((time >> 8) & 0x00ff);

    length();

    spp.sendbytes(tempCharArray, payloadLength);
  }

  public void setOutputState(int time, int freq) {
    payloadLength = 2;
    tempCharArray[payloadLength] = direct;
    tempCharArray[payloadLength++] |= noreplyNeeded;

    tempCharArray[payloadLength++] = beep;

    tempCharArray[payloadLength++] = (char) (freq & 0x00ff);
    tempCharArray[payloadLength++] = (char) ((freq >> 8) & 0x00ff);

    tempCharArray[payloadLength++] = (char) (time & 0x00ff);
    tempCharArray[payloadLength] = (char) ((time >> 8) & 0x00ff);

    length();

    spp.sendbytes(tempCharArray, payloadLength);
  }

}