package stamp.peripheral.wireless.linkmatik;
import stamp.core.*;
import stamp.util.text.*;

public class LinkMatik {

  private static int maxCon   = 4;

  char[]      payload  = new char[Channel.MAX_BUFFER_SIZE];
  char        tempChar = 0;
  private int counter  = 0;
  char        tempLink;
  int         tempLength;

  private Uart       rx;
  private Uart       tx;

  private Channel      controlChannel;
  private Channel[]    channels = new Channel[maxCon]; ;
  private boolean[]    useChannels = new boolean[maxCon]; ;

  private int        tempValue;
  private char[]     outbuf   = new char[50];

  public LinkMatik(Uart tx, Uart rx, String[] bluetoothAddress) {
    this.tx = tx;
    this.rx = rx;

    for (tempChar = 0; tempChar < useChannels.length; tempChar++) {
      useChannels[tempChar] = false;
    }

    this.controlChannel = new Channel((char) 0xff, this);
    for (tempChar = 0; tempChar < bluetoothAddress.length; tempChar++) {
      connect(bluetoothAddress[tempChar], tempChar);
    }
  }

  private void connect(String s, char i) {
    tempValue = Format.bprintf(outbuf, 0, "CALL %s 1101 RFCOMM", s);
    this.controlChannel.sendbytes(outbuf, tempValue);

    this.channels[i] = new Channel(i, this);
    useChannels[i] = true;
  }



  public void receiveFrame(int timeOut) {
    counter = 0;
    while (!rx.byteAvailable()) {
      CPU.delay(105); // waits 10.0254ms
      if (counter++ >= timeOut) { return; }
    }
    while (rx.byteAvailable()) {
      receiveFrame();
    }
  }

  public void receiveFrame() {
    while (rx.byteAvailable()) {
      tempChar = (char) rx.receiveByte();
      while (tempChar != Channel.SOF) {
        tempChar = (char) rx.receiveByte();
      }
      tempLink = (char) rx.receiveByte();
      tempChar = (char) rx.receiveByte();
      // char flag = tempChar & 0xFC;
      tempLength = tempChar & 0x03;
      tempLength |= (int) rx.receiveByte();
      for (int i = 0; i < tempLength; i++) {
        payload[i] = (char) rx.receiveByte();
      }
      tempChar = (char) rx.receiveByte();
      tempChar ^= tempLink;
      if (tempChar != 0xff) {
        // ERROR
      }
      if (channels[tempLink] != null) {
        channels[tempLink].addToBuffer(payload);

      }
    }

  }

  public void send(char[] bytes, int offset) {
        System.out.println("-----------------SEND----START---------------");
    for (int i = 0; i < offset; i++) {
      Format.printf("%c", 0x00ff & bytes[i]);
    }
    System.out.println("\n");
    for (int i = 0; i < offset; i++) {
      tx.sendByte(bytes[i]);
      Format.printf(" 0x%02x", 0x00ff & bytes[i]);
    }
    System.out.println("\n-----------------SEND----END---------------\n\n");
  }
  public Serial getcontrolChannel() {
    return controlChannel;
  }

  public Serial getChannel(int i) {
    return channels[i];
  }




}